<template>
    <div class="system-role">
        <el-card v-show="showSearch" class="search-card">
            <el-form @submit.native.prevent :model="queryParams" ref="queryForm" :inline="true" label-width="78px" class="search-form">
                <el-form-item prop="deptId">
                    <treeselect v-model="queryParams.deptId" :options="deptOptions" :placeholder="$t('user.index.098976-17')" :show-count="true" :clearable="true" :searchable="true" :appendToBody="true" />
                </el-form-item>
                <el-form-item prop="roleName">
                    <el-input v-model="queryParams.roleName" :placeholder="$t('role.index.094567-1')" clearable @keyup.enter.native="handleQuery" />
                </el-form-item>
                <el-form-item prop="status" label-width="55px">
                    <el-select v-model="queryParams.status" :placeholder="$t('role.index.094567-2')" clearable>
                        <el-option v-for="dict in dict.type.sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value" />
                    </el-select>
                </el-form-item>
                <div style="float: right">
                    <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{ $t('search') }}</el-button>
                    <el-button icon="el-icon-refresh" @click="resetQuery">{{ $t('reset') }}</el-button>
                </div>
            </el-form>
        </el-card>

        <el-card>
            <el-row :gutter="10" style="margin-bottom: 16px">
                <el-col :span="1.5">
                    <el-button type="primary" plain icon="el-icon-plus" size="small" @click="handleAdd" v-hasPermi="['system:role:add']">{{ $t('add') }}</el-button>
                </el-col>
                <el-col :span="1.5">
                    <el-button plain icon="el-icon-delete" size="small" :disabled="multiple" @click="handleDelete" v-hasPermi="['iot:role:remove']">{{ $t('del') }}</el-button>
                </el-col>
                <el-col :span="1.5" style="line-height: 32px">
                    <el-checkbox v-model="queryParams.showChild" style="margin: 0px 10px" @change="handleQuery">
                        <div style="color: #606266 !important; font-size: 14px">{{ $t('role.index.094567-4') }}</div>
                    </el-checkbox>
                    <el-tooltip :content="$t('role.index.094567-5')" placement="top"><i class="el-icon-question" style="color: #909399; font-size: 16px"></i></el-tooltip>
                </el-col>
                <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
            </el-row>

            <el-table v-loading="loading" :data="roleList" :border="false" @selection-change="handleSelectionChange">
                <el-table-column type="selection" align="center" width="55" />
                <el-table-column :label="$t('role.index.094567-0')" prop="roleName" :show-overflow-tooltip="true" min-width="200" align="left" />
                <el-table-column :label="$t('role.index.094567-6')" prop="roleKey" :show-overflow-tooltip="true" width="160" align="center" />
                <el-table-column :label="$t('role.index.094567-7')" prop="deptName" align="left" min-width="200" />
                <el-table-column :label="$t('status')" align="center" width="90">
                    <template slot-scope="scope">
                        <el-switch v-model="scope.row.status" :active-value="0" :inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
                    </template>
                </el-table-column>
                <el-table-column :label="$t('role.index.094567-8')" prop="roleSort" width="80" align="center" />
                <el-table-column :label="$t('creatTime')" align="center" prop="createTime" width="180">
                    <template slot-scope="scope">
                        <span>{{ parseTime(scope.row.createTime) }}</span>
                    </template>
                </el-table-column>
                <el-table-column fixed="right" :label="$t('opation')" align="center" class-name="small-padding fixed-width" width="210">
                    <template slot-scope="scope" v-if="scope.row.roleId !== 1">
                        <el-button size="small" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:role:edit']" :disabled="scope.row.canEditRole === false">
                            {{ $t('edit') }}
                        </el-button>
                        <el-button
                            size="small"
                            type="text"
                            icon="el-icon-delete"
                            @click="handleDelete(scope.row)"
                            v-hasPermi="['system:role:remove']"
                            :disabled="scope.row.canEditRole === false || scope.row.manager === true"
                        >
                            {{ $t('del') }}
                        </el-button>
                        <el-button size="small" type="text" icon="el-icon-user" v-hasPermi="['system:role:edit']" @click="handleAuthUser(scope.row)">{{ $t('role.index.094567-12') }}</el-button>
                    </template>
                </el-table-column>
            </el-table>

            <pagination style="margin-bottom: 20px" v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />
        </el-card>

        <!-- 添加或修改角色配置对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="630px" append-to-body>
            <el-form ref="form" :model="form" :rules="rules" label-width="130px">
                <el-form-item :label="$t('user.index.098976-12')" prop="deptId">
                    <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" :placeholder="$t('user.index.098976-17')" :disabled="form.roleId != 0" @input="getMenuList" style="width: 400px" />
                </el-form-item>
                <el-form-item :label="$t('role.index.094567-0')" prop="roleName">
                    <el-input v-model="form.roleName" :placeholder="$t('role.index.094567-1')" :disabled="this.isEdit == true && form.roleId != 0" style="width: 400px" />
                </el-form-item>
                <el-form-item prop="roleKey">
                    <span slot="label">
                        <el-tooltip :content="$t('role.index.094567-14')" placement="top">
                            <i class="el-icon-question"></i>
                        </el-tooltip>
                        {{ $t('role.index.094567-6') }}
                    </span>
                    <el-input v-model="form.roleKey" :placeholder="$t('role.index.094567-15')" :disabled="this.isEdit == true && form.roleId != 0" style="width: 400px" />
                </el-form-item>
                <el-form-item :label="$t('role.index.094567-16')" prop="roleSort">
                    <el-input-number v-model="form.roleSort" controls-position="right" :min="0" style="width: 400px" />
                </el-form-item>
                <el-form-item :label="$t('status')">
                    <el-radio-group v-model="form.status" :disabled="this.isEdit == true && form.roleId != 0">
                        <el-radio v-for="dict in dict.type.sys_normal_disable" :key="dict.value" :label="Number(dict.value)">{{ dict.label }}</el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item :label="$t('remark')">
                    <el-input v-model="form.remark" type="textarea" :autosize="{ minRows: 3, maxRows: 5 }" :placeholder="$t('plzInput')" style="width: 400px"></el-input>
                </el-form-item>
                <el-form-item :label="$t('role.index.094567-17')">
                    <el-checkbox v-model="menuExpand" @change="handleCheckedTreeExpand($event, 'menu')">{{ $t('role.index.094567-18') }}</el-checkbox>
                    <el-checkbox v-model="menuNodeAll" @change="handleCheckedTreeNodeAll($event, 'menu')">{{ $t('role.index.094567-19') }}</el-checkbox>
                    <el-checkbox v-model="form.menuCheckStrictly" @change="handleCheckedTreeConnect($event, 'menu')">{{ $t('role.index.094567-20') }}</el-checkbox>
                    <el-tree
                        style="width: 400px"
                        class="tree-border"
                        :data="menuOptions"
                        show-checkbox
                        ref="menu"
                        node-key="id"
                        :check-strictly="!form.menuCheckStrictly"
                        :empty-text="$t('role.index.094567-21')"
                        :props="defaultProps"
                    ></el-tree>
                </el-form-item>
            </el-form>
            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm">{{ $t('confirm') }}</el-button>
                <el-button @click="cancel">{{ $t('cancel') }}</el-button>
            </div>
        </el-dialog>

        <!-- 分配角色数据权限对话框 -->
        <el-dialog :title="title" :visible.sync="openDataScope" width="500px" append-to-body>
            <el-form :model="form" label-width="80px">
                <el-form-item :label="$t('role.index.094567-0')">
                    <el-input v-model="form.roleName" :disabled="true" />
                </el-form-item>
                <el-form-item :label="$t('role.index.094567-6')">
                    <el-input v-model="form.roleKey" :disabled="true" />
                </el-form-item>
                <el-form-item :label="$t('role.index.094567-22')">
                    <el-select v-model="form.dataScope" @change="dataScopeSelectChange">
                        <el-option v-for="item in dataScopeOptions" :key="item.value" :label="item.label" :value="item.value"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item :label="$t('role.index.094567-23')" v-show="form.dataScope == 2">
                    <el-checkbox v-model="deptExpand" @change="handleCheckedTreeExpand($event, 'dept')">{{ $t('role.index.094567-18') }}</el-checkbox>
                    <el-checkbox v-model="deptNodeAll" @change="handleCheckedTreeNodeAll($event, 'dept')">{{ $t('role.index.094567-19') }}</el-checkbox>
                    <el-checkbox v-model="form.deptCheckStrictly" @change="handleCheckedTreeConnect($event, 'dept')">{{ $t('role.index.094567-20') }}</el-checkbox>
                    <el-tree
                        class="tree-border"
                        :data="deptOptions"
                        show-checkbox
                        default-expand-all
                        ref="dept"
                        node-key="id"
                        :check-strictly="!form.deptCheckStrictly"
                        :empty-text="$t('role.index.094567-21')"
                        :props="defaultProps"
                    ></el-tree>
                </el-form-item>
            </el-form>
            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitDataScope">{{ $t('confirm') }}</el-button>
                <el-button @click="cancelDataScope">{{ $t('cancel') }}</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listRole, getRole, delRole, addRole, updateRole, dataScope, changeRoleStatus, deptTreeSelect } from '@/api/system/role';
import { deptsTreeSelect } from '@/api/system/user';
import { treeselect as menuTreeselect, roleMenuTreeselect, partMenuTreeselect } from '@/api/system/menu';
import Treeselect from '@riophae/vue-treeselect';
import '@riophae/vue-treeselect/dist/vue-treeselect.css';

export default {
    name: 'Role',
    dicts: ['sys_normal_disable'],
    components: { Treeselect },
    data() {
        return {
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 角色表格数据
            roleList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 是否显示弹出层（数据权限）
            openDataScope: false,
            menuExpand: false,
            menuNodeAll: false,
            deptExpand: true,
            deptNodeAll: false,
            isEdit: true,
            // 日期范围
            dateRange: [],
            // 数据范围选项
            dataScopeOptions: [
                {
                    value: '1',
                    label: this.$t('role.index.094567-24'),
                },
                {
                    value: '2',
                    label: this.$t('role.index.094567-25'),
                },
                {
                    value: '3',
                    label: this.$t('role.index.094567-26'),
                },
                {
                    value: '4',
                    label: this.$t('role.index.094567-27'),
                },
                {
                    value: '5',
                    label: this.$t('role.index.094567-28'),
                },
            ],
            // 菜单列表
            menuOptions: [],
            // 小程序菜单列表
            miniMenuOptions: [],
            // 部门列表
            deptOptions: [],
            // 查询参数
            queryParams: {
                pageNum: 1,
                pageSize: 10,
                roleName: undefined,
                roleKey: undefined,
                status: undefined,
                deptId: null,
                showChild: true,
            },
            // 表单参数
            form: {},
            defaultProps: {
                children: 'children',
                label: 'label',
            },
            // 表单校验
            rules: {
                deptId: [{ required: true, message: this.$t('role.index.094567-29'), trigger: 'blur' }],
                roleName: [{ required: true, message: this.$t('role.index.094567-30'), trigger: 'blur' }],
                roleKey: [{ required: true, message: this.$t('role.index.094567-31'), trigger: 'blur' }],
                roleSort: [{ required: true, message: this.$t('role.index.094567-32'), trigger: 'blur' }],
            },
        };
    },
    created() {
        const deptId = this.$route.params && this.$route.params.deptId;
        if (deptId) {
            this.queryParams.deptId = deptId;
            this.getList();
        } else {
            this.getList();
        }
        this.getDeptTrees();
    },
    methods: {
        /** 查询角色列表 */
        getList() {
            this.loading = true;
            listRole(this.addDateRange(this.queryParams, this.dateRange)).then((response) => {
                this.roleList = response.rows;
                this.total = response.total;
                this.loading = false;
            });
        },
        /** 查询机构下拉树结构 */
        getDeptTrees() {
            deptsTreeSelect().then((response) => {
                this.deptOptions = response.data;
            });
        },
        /** 查询菜单树结构 */
        getMenuTreeselect() {
            menuTreeselect().then((response) => {
                this.menuOptions = response.data;
            });
        },
        //根据机构id来查询菜单列表
        getMenuList() {
            if (this.form.deptId != undefined && this.form.deptId != null && this.form.roleId == 0) {
                const id = this.form.deptId;
                partMenuTreeselect(id).then((response) => {
                    this.menuOptions = response.data;
                });
            }
        },
        // 所有菜单节点数据
        getMenuAllCheckedKeys() {
            // 目前被选中的菜单节点
            let checkedKeys = this.$refs.menu.getCheckedKeys();
            // 半选中的菜单节点
            let halfCheckedKeys = this.$refs.menu.getHalfCheckedKeys();
            checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys);
            return checkedKeys;
        },
        // 所有部门节点数据
        getDeptAllCheckedKeys() {
            // 目前被选中的部门节点
            let checkedKeys = this.$refs.dept.getCheckedKeys();
            // 半选中的部门节点
            let halfCheckedKeys = this.$refs.dept.getHalfCheckedKeys();
            checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys);
            return checkedKeys;
        },
        /** 根据角色ID查询菜单树结构 */
        getRoleMenuTreeselect(roleId, deptId) {
            // const deptId = this.form.deptId;
            return roleMenuTreeselect(roleId, deptId).then((response) => {
                this.menuOptions = response.menus;
                return response;
            });
        },
        /** 根据角色ID查询部门树结构 */
        getDeptTree(roleId) {
            return deptTreeSelect(roleId).then((response) => {
                this.deptOptions = response.depts;
                return response;
            });
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.roleId);
            this.single = selection.length !== 1;
            this.multiple = !selection.length;
        },
        // 角色状态修改
        handleStatusChange(row) {
            let text = row.status === '0' ? this.$t('simulate.index.111543-54') : this.$t('simulate.index.111543-55');
            this.$modal
                .confirm(this.$t('user.index.098976-40') + text + '' + row.roleName + this.$t('role.index.094567-37'))
                .then(function () {
                    return changeRoleStatus(row.roleId, row.status);
                })
                .then(() => {
                    this.$modal.msgSuccess(text + this.$t('success'));
                })
                .catch(function () {
                    row.status = row.status === 0 ? 1 : 0;
                });
        },
        // 取消按钮
        cancel() {
            this.open = false;
            this.reset();
        },
        // 取消按钮（数据权限）
        cancelDataScope() {
            this.openDataScope = false;
            this.reset();
        },
        // 表单重置
        reset() {
            if (this.$refs.menu != undefined) {
                this.$refs.menu.setCheckedKeys([]);
            }
            (this.menuExpand = false),
                (this.menuNodeAll = false),
                (this.deptExpand = true),
                (this.deptNodeAll = false),
                (this.form = {
                    roleId: 0,
                    roleName: undefined,
                    roleKey: undefined,
                    roleSort: 0,
                    status: 0,
                    deptId: null,
                    menuIds: [],
                    deptIds: [],
                    menuCheckStrictly: true,
                    deptCheckStrictly: true,
                    remark: undefined,
                });
            this.resetForm('form');
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageNum = 1;
            this.getList();
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.dateRange = [];
            this.resetForm('queryForm');
            this.handleQuery();
        },
        // 树权限（展开/折叠）
        handleCheckedTreeExpand(value, type) {
            if (type == 'menu') {
                let treeList = this.menuOptions;
                for (let i = 0; i < treeList.length; i++) {
                    this.$refs.menu.store.nodesMap[treeList[i].id].expanded = value;
                }
            } else if (type == 'dept') {
                let treeList = this.deptOptions;
                for (let i = 0; i < treeList.length; i++) {
                    this.$refs.dept.store.nodesMap[treeList[i].id].expanded = value;
                }
            }
        },
        // 树权限（全选/全不选）
        handleCheckedTreeNodeAll(value, type) {
            if (type == 'menu') {
                this.$refs.menu.setCheckedNodes(value ? this.menuOptions : []);
            } else if (type == 'dept') {
                this.$refs.dept.setCheckedNodes(value ? this.deptOptions : []);
            }
        },
        // 树权限（父子联动）
        handleCheckedTreeConnect(value, type) {
            if (type == 'menu') {
                this.form.menuCheckStrictly = value ? true : false;
            } else if (type == 'dept') {
                this.form.deptCheckStrictly = value ? true : false;
            }
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset();
            this.getMenuTreeselect();
            this.open = true;
            this.title = this.$t('role.index.094567-33');
            this.isEdit = true;
            this.getMenuList();
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset();
            const roleId = row.roleId || this.ids;
            const deptId = row.deptId;
            const roleMenu = this.getRoleMenuTreeselect(roleId, deptId);
            this.isEdit = row.manager;
            getRole(roleId).then((response) => {
                this.form = response.data;
                this.open = true;
                this.$nextTick(() => {
                    roleMenu.then((res) => {
                        let checkedKeys = res.checkedKeys;
                        checkedKeys.forEach((v) => {
                            this.$nextTick(() => {
                                this.$refs.menu.setChecked(v, true, false);
                            });
                        });
                    });
                });
                this.title = this.$t('role.index.094567-34');
            });
        },
        /** 选择角色权限范围触发 */
        dataScopeSelectChange(value) {
            if (value !== '2') {
                this.$refs.dept.setCheckedKeys([]);
            }
        },
        /** 分配数据权限操作 */
        handleDataScope(row) {
            this.reset();
            const deptTreeSelect = this.getDeptTree(row.roleId);
            getRole(row.roleId).then((response) => {
                this.form = response.data;
                this.openDataScope = true;
                this.$nextTick(() => {
                    deptTreeSelect.then((res) => {
                        this.$refs.dept.setCheckedKeys(res.checkedKeys);
                    });
                });
                this.title = this.$t('role.index.094567-35');
            });
        },
        /** 分配用户操作 */
        handleAuthUser: function (row) {
            const roleId = row.roleId;
            this.$router.push('/system/role-auth/user/' + roleId);
        },
        /** 提交按钮 */
        submitForm: function () {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    if (this.form.roleId != 0) {
                        this.form.menuIds = this.getMenuAllCheckedKeys();
                        updateRole(this.form).then((response) => {
                            this.$modal.msgSuccess(this.$t('updateSuccess'));
                            this.open = false;
                            this.getList();
                        });
                    } else {
                        this.form.menuIds = this.getMenuAllCheckedKeys();
                        addRole(this.form).then((response) => {
                            this.$modal.msgSuccess(this.$t('addSuccess'));
                            this.open = false;
                            this.getList();
                        });
                    }
                }
            });
        },
        /** 提交按钮（数据权限） */
        submitDataScope: function () {
            if (this.form.roleId != 0) {
                this.form.deptIds = this.getDeptAllCheckedKeys();
                dataScope(this.form).then((response) => {
                    this.$modal.msgSuccess(this.$t('updateSuccess'));
                    this.openDataScope = false;
                    this.getList();
                });
            }
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const roleIds = row.roleId || this.ids;
            this.$modal
                .confirm(this.$t('role.index.094567-36', [roleIds]))
                .then(function () {
                    return delRole(roleIds);
                })
                .then(() => {
                    this.getList();
                    this.$modal.msgSuccess(this.$t('delSuccess'));
                })
                .catch(() => {});
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'system/role/export',
                {
                    ...this.queryParams,
                },
                `role_${new Date().getTime()}.xlsx`
            );
        },
    },
};
</script>

<style lang="scss" scoped>
.system-role {
    padding: 20px;

    .search-card {
        margin-bottom: 15px;
        padding: 3px 0;
    }

    .search-form {
        margin-bottom: -22.5px;
    }

    ::v-deep .vue-treeselect {
        width: 217.5px;
        height: 36px;
        line-height: 33.2px;
        font-size: 14px;
    }

    ::v-deep .vue-treeselect__control {
        height: 33.2px;
    }

    ::v-deep .vue-treeselect__placeholder {
        line-height: 36px;
    }

    ::v-deep .vue-treeselect__single-value {
        line-height: 33.2px;
    }

    ::v-deep .vue-treeselect__input {
        height: 33.2px;
    }
}
</style>
